
#include "sk_defination.h"

void calibrate_upf_function(void)
{
  // STOP ADC CONVERSION TO CALIBRATE
      SD16CCTL_VOLTAGE &= ~SD16SC;
      SD16CCTL_LIVE &= ~SD16SC;
      SD16CCTL_NEUTRAL &= ~SD16SC;
      
      _DINT();
      
//      button_press_time=50;             
      volt_cal_factor_R=(sqrt((float)present_instt_voltage_R))/24000000; // up to 5 decimal point
      volt_cal_factor_Y=(sqrt((float)present_instt_voltage_Y))/24000000;
      volt_cal_factor_B=(sqrt((float)present_instt_voltage_B))/24000000;
      
      curr_cal_factor_R=(sqrt((float)present_ct_cutrent_R))/100000000;     // up to 7 decimal point
      curr_cal_factor_Y=(sqrt((float)present_ct_cutrent_Y))/100000000;
      curr_cal_factor_B=(sqrt((float)present_ct_cutrent_B))/100000000;
      
      msp_wattage=present_instt_watt_R;
      if(msp_wattage>0x80000000)
      {
        msp_wattage=~msp_wattage;          
      }      
      load_cal_factor_R=((float)msp_wattage/240000000);         // up to 5 decimal point
      
      msp_wattage=present_instt_watt_Y;
      if(msp_wattage>0x80000000)
      {
        msp_wattage=~msp_wattage;          
      }
      load_cal_factor_Y=((float)msp_wattage/240000000);         // up to 5 decimal point
      
      msp_wattage=present_instt_watt_B;
      if(msp_wattage>0x80000000)
      {
        msp_wattage=~msp_wattage;          
      }
      load_cal_factor_B=((float)msp_wattage/240000000);         // up to 5 decimal point
          
      freq_cal_factor_R=(sqrt((float)Freq_count))/0.02; // Time period of 50Hz freq = 1/50 =0.02
     
      if(cal_done==75)
      {_NOP();}
      else
      {cal_done=50;}      
      
       array_flash_write[0]=volt_cal_factor_R;
       array_flash_write[1]=volt_cal_factor_Y;
       array_flash_write[2]=volt_cal_factor_B;
       array_flash_write[3]=curr_cal_factor_R;
       array_flash_write[4]=curr_cal_factor_Y;
       array_flash_write[5]=curr_cal_factor_B;
       array_flash_write[6]=freq_cal_factor_R;
       array_flash_write[7]=freq_cal_factor_Y;
       array_flash_write[8]=freq_cal_factor_B;
       array_flash_write[9]=cal_done;
       array_flash_write[10]=load_cal_factor_R;
       array_flash_write[11]=load_cal_factor_Y;
       array_flash_write[12]=load_cal_factor_B;         
       
       flash_write_segmentA(0x1080,0);        
             
       tensec=0;
       
       // START ADC CONVERSION
       AnalogFrontEnd_init();
       
       _EINT();
} // end of calibrate_upf_function


void calibrate_pf_function(void)
{
  unsigned int watt_check_R=0;
  unsigned int watt_check_Y=0;
  unsigned int watt_check_B=0;
    
  msp_wattage=present_instt_watt_R;
  if(msp_wattage>0x80000000)
  {
    msp_wattage=~msp_wattage;          
  }
  instt_watt_R= (signed long)((float)msp_wattage/load_cal_factor_R);          
  watt_check_R=(unsigned int)(((float)instt_watt_R/60000000)*1000);
  
  if(watt_check_R>1000)
  {
    watt_check_R-=1000;
    unsigned char cal_var_R=(char)((watt_check_R*6)/10);
    cal_var_R=(cal_var_R*3);
    SD16PRE_VAL_CH_0-=cal_var_R;
  }
  else if(watt_check_R<1000)
  {
    watt_check_R=1000-watt_check_R;
    unsigned char cal_var_R=(char)((watt_check_R*6)/10);
    SD16PRE_VAL_CH_0=0;
    SD16PRE_VAL_CH_0+=(cal_var_R*3);
  }
  
  
  msp_wattage=present_instt_watt_Y;
  if(msp_wattage>0x80000000)
  {
    msp_wattage=~msp_wattage;          
  }
  instt_watt_Y= (signed long)((float)msp_wattage/load_cal_factor_Y);          
  watt_check_Y=(unsigned int)(((float)instt_watt_Y/60000000)*1000);
  
  if(watt_check_Y>1000)
  {
    watt_check_Y-=1000;
    unsigned char cal_var_Y=(char)((watt_check_Y*6)/10);
    cal_var_Y=(cal_var_Y*3);
    SD16PRE_VAL_CH_1-=cal_var_Y;
  }
  else if(watt_check_Y<1000)
  {
    watt_check_Y=1000-watt_check_Y;
    unsigned char cal_var_Y=(char)((watt_check_Y*6)/10);
    SD16PRE_VAL_CH_1=0;
    SD16PRE_VAL_CH_1+=(cal_var_Y*3);
  }
  
  
  msp_wattage=present_instt_watt_B;
  if(msp_wattage>0x80000000)
  {
    msp_wattage=~msp_wattage;          
  }
  instt_watt_B= (signed long)((float)msp_wattage/load_cal_factor_B);          
  watt_check_B=(unsigned int)(((float)instt_watt_B/60000000)*1000);
  
  if(watt_check_B>1000)
  {
    watt_check_B-=1000;
    unsigned char cal_var_B=(char)((watt_check_B*6)/10);
    cal_var_B=(cal_var_B*3);
    SD16PRE_VAL_CH_2-=cal_var_B;
  }
  else if(watt_check_B<1000)
  {
    watt_check_B=1000-watt_check_B;
    unsigned char cal_var_B=(char)((watt_check_B*6)/10);
    SD16PRE_VAL_CH_2=0;
    SD16PRE_VAL_CH_2+=(cal_var_B*3);
  }
  
  cal_done=75;
  AnalogFrontEnd_init(); 
  
  //////////////////////////////////////////////////////
  //////// Routine for check and recalibrate ///////////
  //////////////////////////////////////////////////////
  /*
    // DELETED, BUT COPY FROM REFERENCE METER DESIGN IF NEEDED
  */  
/////////////////////////////////////////////////////////////////
  
  cal_done=75;
  
  array_flash_write[13]=SD16PRE_VAL_CH_0;
  array_flash_write[14]=SD16PRE_VAL_CH_1;
  array_flash_write[15]=SD16PRE_VAL_CH_2;
  array_flash_write[9]=cal_done;
   
   
  flash_write_segmentA(0x1080,0);
  
  Delay_10ms();
  Delay_10ms();
  cum_watt=0;
  set_memory_data_long(cum_watt,0);          
  eeprom_write(cum_watt_address,0x04);

  cum_watt_KWH=0;
  set_memory_data_long(cum_watt_KWH,0);
  eeprom_write(cum_watt_KWH_address,0x04);
  
} // end of calibrate_pf_function



void flash_write_segmentA(unsigned int address,char start_address) //float *array)
{
float *Flash_ptr; 

Flash_ptr = (float *) address;//0x1080; // Initialize Flash pointer
//Flash_ptr += position; // Jump to desired address
FCTL1 = FWKEY + ERASE; // Set Erase bit
FCTL3 = FWKEY; // Clear Lock bit
*Flash_ptr = 0; // Dummy write to erase Flash segment

FCTL1 = FWKEY + WRT; // Set WRT bit for write operation

for(char i=start_address;i<32;i++)
  {
    *Flash_ptr=array_flash_write[i];
    Delay_10ms();
    Flash_ptr++;   
  }

FCTL1 = FWKEY; // Clear WRT bit
FCTL3 = FWKEY + LOCK; // Set LOCK bit
}

void read_flash(unsigned int address,char start_address)
{
  float *ptr;
  ptr=(float *)address;//0x1080;       
  for(char k=start_address;k<32;k++)
  {
   array_flash_write[k]=*ptr; 
   Delay_10ms();   
   ptr++;
  }     
}
